/**
 * @filename: MyGenerator.java 2019-10-16
 * @project v0.0.1  V1.0
 * Copyright(c) 2018 BianPeng Co. Ltd. 
 * All right reserved. 
 */
package com.flying.cattle.mdg;

import java.io.IOException;
import java.io.Serializable;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;

import com.alibaba.druid.support.json.JSONUtils;
import com.gitee.flying.cattle.mdg.entity.BasisInfo;
import com.gitee.flying.cattle.mdg.util.EntityInfoUtil;
import com.gitee.flying.cattle.mdg.util.Generator;
import com.gitee.flying.cattle.mdg.util.MySqlToJavaUtil;

import javax.swing.text.DateFormatter;

/**
 * Copyright: Copyright (c) 2019 
 * 
 * <p>说明： 自动生成工具</P>
 * <p>源码地址：https://gitee.com/flying-cattle/mybatis-dsc-generator</P>
 */
public class MyGenerator implements Serializable {
		// 基础信息：项目名、作者、版本
		public static final String PROJECT = "doctor";
		public static final String AUTHOR = "yubaogu";
		public static final String VERSION = "V1.0";
		// 数据库连接信息：连接URL、用户名、秘密、数据库名
		public static final String URL = "jdbc:mysql://120.26.213.52:3306/ydl?useSSL=false&serverTimezone=GMT%2B8&useUnicode=true&characterEncoding=utf8";
		public static final String NAME = "ydl";
		public static final String PASS = "tt12345";
		public static final String DATABASE = "ydl";
		// 类信息：类名、对象名（一般是【类名】的首字母小些）、类说明、时间
		public static final String TABLE = "doctor";
		public static final String[] TABLES = {"log_system"
		};
	/**
	  "doctor_base_data","doctor_order","doctor","expert_interview","expert_interview_result","expert_result",
	  				"doctor_education","doctor_certificate","doctor_certification","doctor_handle_cfg",
	  				"doctor_team_certification","doctor_certificate","doctor_spirit_qualification","doctor_spirit_qualification","doctor_training_background",
	  				"config_role","doctor_template","doctor_honorary_title","doctor_honorary_title","doctor_ren_zhi_background","doctor_interview",
	  				"doctor_examine","doctor_examine_type_info","doctor_examine_flow","doctor_examine_log","doctor_modify",
	 */
	public static final String CLASSCOMMENT = "专家";
		public static final String TIME = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());
		public static final String AGILE = new Date().getTime() + "";
		// 路径信息，分开路径方便聚合工程项目，微服务项目
		public static  String ENTITY_URL = "com.ydl.*project*.intf.po";
		public static  String DAO_URL = "com.ydl.*project*.service.mapper";
		public static  String XML_URL = "sqlmap\\";
		public static  String SERVICE_URL = "com.ydl.*project*.service.biz";
		public static  String SERVICE_IMPL_URL = "com.ydl.*project*.service.biz.impl";
		public static  String FACADE_URL = "com.ydl.*project*.intf.facade";
		public static  String FACADE_URL_IMPL = "com.ydl.*project*.service.facade";
		public static  String CONTROLLER_URL = "com.ydl.*project*.api.apis";
		//是否是Swagger配置
		public static final String IS_SWAGGER = "true";

		public static final String PROJECT_NAME = "log";
		
	public static void main(String[] args) throws IOException {
		System.out.println(MyGenerator.class.getResource("").getPath());
		ENTITY_URL = ENTITY_URL.replace("*project*",PROJECT_NAME);
		DAO_URL = DAO_URL.replace("*project*",PROJECT_NAME);
		SERVICE_URL = SERVICE_URL.replace("*project*",PROJECT_NAME);
		SERVICE_IMPL_URL = SERVICE_IMPL_URL.replace("*project*",PROJECT_NAME);
		FACADE_URL = FACADE_URL.replace("*project*",PROJECT_NAME);
		FACADE_URL_IMPL = FACADE_URL_IMPL.replace("*project*",PROJECT_NAME);
		CONTROLLER_URL = CONTROLLER_URL.replace("*project*",PROJECT_NAME);
		BasisInfo bi = new BasisInfo(PROJECT, AUTHOR, VERSION, URL, NAME, PASS, DATABASE, TIME, AGILE, ENTITY_URL,
				DAO_URL, XML_URL, SERVICE_URL, SERVICE_IMPL_URL,FACADE_URL, FACADE_URL_IMPL, CONTROLLER_URL,IS_SWAGGER);
		for(String table : TABLES) {
			bi.setTable(table);
			bi.setEntityName(MySqlToJavaUtil.getClassName(table));
			bi.setObjectName(MySqlToJavaUtil.changeToJavaFiled(table));
			bi.setEntityComment(CLASSCOMMENT);
			try {
				bi = EntityInfoUtil.getInfo(bi);
				String localproject = "D:\\ydlwork\\ydl_log\\";
				String fileServiceUrl = localproject + "ydl-*project*-service\\src\\main\\"+ "java\\";// 生成文件存放位置
				String fileServiceMapper = localproject +  "ydl-*project*-service\\src\\main\\" + "resources\\";// 生成文件存放位置
				String fileIntfUrl = localproject +  "ydl-*project*-intf\\src\\main\\java\\";// 生成文件存放位置
				String fileApiUrl = localproject +  "ydl-*project*-api\\src\\main\\java\\";// 生成文件存放位置

				fileServiceUrl = fileServiceUrl.replace("*project*",PROJECT_NAME);
				fileServiceMapper = fileServiceMapper.replace("*project*",PROJECT_NAME);
				fileIntfUrl = fileIntfUrl.replace("*project*",PROJECT_NAME);
				fileApiUrl = fileApiUrl.replace("*project*",PROJECT_NAME);

				//开始生成文件
				String aa1 = Generator.createEntity(fileIntfUrl, bi).toString();
				String aa2 = Generator.createDao(fileServiceUrl, bi).toString();
				String aa3 = Generator.createDaoImpl(fileServiceMapper, bi).toString();
				String aa4 = Generator.createService(fileServiceUrl, bi).toString();
				String aa5 = Generator.createServiceImpl(fileServiceUrl, bi).toString();
				//String aa6 = Generator.createController(fileApiUrl, bi).toString();
					// 是否创建swagger配置文件
				//String aa7 = Generator.createSwaggerConfig(fileUrl, bi).toString();

				String aa9 = Generator.createFacade(fileIntfUrl, bi).toString();
				String aa10 = Generator.createFacadeImpl(fileServiceUrl, bi).toString();

				System.out.println(aa1);
				System.out.println(aa2);
				System.out.println(aa3);
				System.out.println(aa4);
				System.out.println(aa5);
				//System.out.println(aa6);
				//System.out.println(aa7);

				//System.out.println(aa9);
				//System.out.println(aa10);
				} catch (SQLException e) {
					e.printStackTrace();
				}
		}
	}
}
